//+------------------------------------------------------------------+
//|                                AlexSTAL  .mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

extern int RefreshPeriodMin = 1;
extern string Instruments1 = "AUDCAD,AUDCHF,AUDDKK,AUDJPY,AUDNOK,AUDNZD,AUDSEK,AUDSGD,AUDUSD,CADCHF,CADJPY,CHFJPY,CHFNOK,CHFSGD,EURAUD,EURCAD,EURCHF,EURDKK,EURGBP,EURHKD,EURJPY,EURNOK,EURNZD,EURSEK,EURSGD,EURUSD,GBPAUD,GBPCAD,GBPCHF,GBPDKK,GBPJPY,GBPNOK,GBPSEK,GBPSGD,GBPUSD,NZDCAD";
extern string Instruments2 = "NZDCHF,NZDJPY,NZDSGD,NZDUSD,SGDJPY,USDCAD,USDCHF,USDDKK,USDHKD,USDJPY,USDMXN,USDNOK,USDSEK,USDSGD,USDZAR,XAGUSD,XAUUSD,#CFU0,#ESU0,#GXU0,#NQU0,#NXU0,#ZU0,#CU0,#GCQ0,#GCZ0,#SIU0,#SX0,#WU0,#QGU0,#QGV0,#QMV0";
extern string Instruments3 = "";

string Instruments[];
double Result[][3]; //   ,   -   

extern int Stoch_D = 12;
extern int Stoch_K = 8;
extern int Stoch_S = 5;
extern double Koef = 1.2;

double D10,D11,D12,D13,D14,D15,D16,D17;
double K10,K11,K12,K13,K14,K15,K16,K17;
double S10,S11,S12,S13,S14,S15,S16,S17;

//+------------------------------------------------------------------+
datetime LastRefresh;
//string shortname;
//+------------------------------------------------------------------+
void CloseGroupingOfShots(double Massiv[], double& res1, double& res2)
{
	res1 = 0; res2 = 0;
	int i = 0;
	double j = 0;
	
	int Variant = 0;
	
	if (Variant == 0)
	{
		double MO, D, SKO;
		j = ArraySize(Massiv);
		if (j == 0)
			return(0);
		for (MO = 0, i = 0; i < j; i++)
			MO += Massiv[i];
		MO /= j;
		if (MO == 0)
			return(0);

		for (D = 0, i = 0; i < j; i++)
			D += MathPow( Massiv[i] - MO, 2.0);
		D /= j;

		SKO = MathPow( D, 0.5 );
		res1 = ( 1.0 - SKO / MathAbs( MO ) ) * 100.0;
		res2 = MO;
	}
	
	if (Variant == 1)
	{
		double Min = 0, Max = 0, Sred;
		j = ArraySize(Massiv);
		if (j == 0)
			return(0);
		double tmp;
		for (i = 0; i < j; i++)
	 	{
	 		tmp = Massiv[i];
	 		Sred += tmp;
	 		if (Min > tmp)
	 			Min = tmp;
	 		if (Max < tmp)
	 			Max = tmp;
	 	}
		Sred /= j;
		if ( (Sred == 0) || (Max == 0) )
			return(0);
		
		res1 = ((Min / Sred) + (Sred / Max)) / 2 * 100;
		res2 = Sred;
	}
}

//+------------------------------------------------------------------+
void GetResultForInstrument(string Instrument, int shift, double& var1, double& var2)
{
	double Value[8];
	Value[0] = iStochastic(Instrument,0,D10,K10,S10,3,1,0,shift);
	Value[1] = iStochastic(Instrument,0,D11,K11,S11,3,1,0,shift);
	Value[2] = iStochastic(Instrument,0,D12,K12,S12,3,1,0,shift);
	Value[3] = iStochastic(Instrument,0,D13,K13,S13,3,1,0,shift);
	Value[4] = iStochastic(Instrument,0,D14,K14,S14,3,1,0,shift);
	Value[5] = iStochastic(Instrument,0,D15,K15,S15,3,1,0,shift);
	Value[6] = iStochastic(Instrument,0,D16,K16,S16,3,1,0,shift);
	Value[7] = iStochastic(Instrument,0,D17,K17,S17,3,1,0,shift);
	double res1 = 0;
	double res2 = 0;
	CloseGroupingOfShots(Value, res1, res2);
	var1 = res1;
	var2 = res2;
}
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
	LastRefresh = TimeCurrent() - RefreshPeriodMin*60;
	//   
	string tmpstr;
	string getinstr;
	int i;
	for (int j = 0; j <3; j++)
	 {
	 	switch(j)
	 	 {
   		case 0:
				tmpstr = Instruments1;
      		break;
   		case 1:
				tmpstr = Instruments2;
      		break;
   		case 2:
				tmpstr = Instruments3;
      		break;
   		default:
				tmpstr = "";
      		break;
	 	 }
		while(true)
	 	{
			i = StringFind(tmpstr, ",", 0);
			if (i != -1)
		 	{
		 		getinstr = StringSubstr(tmpstr, 0, i);
		 		tmpstr = StringSubstr(tmpstr, i+1);
		 	} else {
		 		getinstr = tmpstr;
		 		tmpstr = "";
		 	}
		 	//----------------------------------
		 	getinstr = StringTrimLeft(getinstr);
		 	getinstr = StringTrimRight(getinstr);
		 	if (MarketInfo(getinstr, MODE_BID) != 0)
		  	{
		  		ArrayResize(Instruments, ArraySize(Instruments) + 1);
		  		Instruments[ArraySize(Instruments)-1] = getinstr;
		  	
		  	}
		 	//----------------------------------
		 	if (tmpstr == "")
		 		break;
	 	}
	 }
	//----
	ArrayResize(Result, ArraySize(Instruments));
  	//   
   D10=Stoch_D;D11=D10*Koef;D12=D11*Koef;D13=D12*Koef;D14=D13*Koef;D15=D14*Koef;D16=D15*Koef;D17=D16*Koef;
   K10=Stoch_K;K11=K10*Koef;K12=K11*Koef;K13=K12*Koef;K14=K13*Koef;K15=K14*Koef;K16=K15*Koef;K17=K16*Koef;
   S10=Stoch_S;S11=S10*Koef;S12=S11*Koef;S13=S12*Koef;S14=S13*Koef;S15=S14*Koef;S16=S15*Koef;S17=S16*Koef;
	//----
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
	//----
	int j = ArrayRange(Result, 0);
	for (int i = 0; i < j; i++)
	 {
		string objname = "CloseGroupingOfShots" + i;
		if (ObjectFind(objname)>=0)
			ObjectDelete(objname);
	 }
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	if (ArraySize(Instruments) == 0)
	 {
		Comment("  ");
		return(0);
	 }
	if ( TimeCurrent() < (LastRefresh + RefreshPeriodMin*60) )
		return(0);
	LastRefresh = TimeCurrent();
	
	//int    counted_bars=IndicatorCounted();
	
	int j = ArrayRange(Result, 0);
	int i = j;
	while (i > 0)
	{
    	i--;
    	Result[i][1] = i;
	}
	
	//     
	double var1, var2;
	for (i = 0; i < j; i++)
	 {
	 	GetResultForInstrument(Instruments[i], 0, var1, var2);
	 	Result[i][0] = var1;
	 	Result[i][2] = var2;
	 	//Result[i][0] = GetResultForInstrument(Instruments[i], 0);
	 }
	
	//       .
	ArraySort(Result, WHOLE_ARRAY, 0, MODE_DESCEND);
	
	//
	double Res;
	int index;
	string objname;
	for (i = 0; i < j; i++)
	 {
		index = Result[i][1];
		//Print(Instruments[index] + " = " + Result[i][0]);
		objname = "CloseGroupingOfShots" + i;
		if (ObjectFind(objname)<0)
		 {
			ObjectCreate(objname, OBJ_LABEL, 0, 0, 0);
			ObjectSet(objname, OBJPROP_XDISTANCE, 15);
			ObjectSet(objname, OBJPROP_YDISTANCE, 15 + 10 * i);
		 }
		color ColorLabel;
		Res = Result[i][0];
		if (Res >= 80)
			ColorLabel = Red;
		else
			ColorLabel = DimGray;
		string out = Instruments[index] + " = " + DoubleToStr(Result[i][0], 1) + "% (" + DoubleToStr(Result[i][2], 1) + ")";
		ObjectSetText(objname, out, 8, "Times New Roman", ColorLabel);
	 }
   
	//----
   return(0);
}
//+------------------------------------------------------------------+